[CCode (cprefix = "Vala", lower_case_cprefix = "vala_")]
namespace Vala {
	[CCode (cheader_filename = "gobject/valaccodecompiler.h")]
	public class CCodeCompiler : GLib.Object {
		public CCodeCompiler ();
		[NoArrayLength]
		public void compile (Vala.CodeContext! context, string cc_command, string[] cc_options);
	}
	[CCode (cheader_filename = "gobject/valaclassregisterfunction.h")]
	public class ClassRegisterFunction : Vala.TypeRegisterFunction {
		public ClassRegisterFunction (Vala.Class! cl);
		public weak Vala.Class! class_reference { get; set; }
	}
	[CCode (cheader_filename = "gobject/valacodegenerator.h")]
	public class CodeGenerator : Vala.CodeVisitor {
		public CodeGenerator (bool manage_memory = true);
		public void emit (Vala.CodeContext! context);
		public weak bool memory_management { get; set; }
	}
	[CCode (cheader_filename = "gobject/valainterfaceregisterfunction.h")]
	public class InterfaceRegisterFunction : Vala.TypeRegisterFunction {
		public InterfaceRegisterFunction (Vala.Interface! iface);
		public weak Vala.Interface! interface_reference { get; set; }
	}
	[CCode (cheader_filename = "gobject/valatyperegisterfunction.h")]
	public abstract class TypeRegisterFunction : GLib.Object {
		public void init_from_type (bool plugin = false);
		public abstract Vala.DataType! get_type_declaration ();
		public abstract string! get_type_struct_name ();
		public abstract string! get_base_init_func_name ();
		public abstract string! get_class_init_func_name ();
		public abstract string! get_instance_struct_size ();
		public abstract string! get_instance_init_func_name ();
		public abstract string! get_parent_type_name ();
		public virtual string get_type_flags ();
		public virtual Vala.CCodeFragment! get_type_interface_init_declaration ();
		public abstract Vala.CCodeFragment! get_type_interface_init_statements ();
		public Vala.CCodeFragment! get_declaration ();
		public Vala.CCodeFragment! get_definition ();
	}
}
